package adm.poc;
import java.util.*;

import bogda.api.clmt.ClmtFunction;
import bogda.api.clmt.FunctionArgumens;

public class TreeFilter extends ClmtFunction {

	@Override
	public Object run(FunctionArgumens args) {
		Object data = args.getArgument(0);

		Object cId = args.getArgument(1);
		List<String> childrenId;
		if(cId instanceof String)
			childrenId = Arrays.asList((String) cId);
		else if(cId instanceof List)
			childrenId = (List<String>) cId;
		else
			childrenId = Arrays.asList("children");

		if(data instanceof Map)
			return filterItem((Map)data, childrenId, args);
		else if (data instanceof List)
			return filterList((List)data, childrenId, args);
			
		return null;
	}
	
	private Object filterItem(Map<Object, Object> item, List<String> childrenId, FunctionArgumens args) {
		args.setLocalVar("this", item);
		if(Boolean.TRUE.equals(args.getArgument(2, true))) {
			LinkedHashMap newMap = new LinkedHashMap();
			for(Map.Entry<Object, Object> entry : item.entrySet()) {
				Object key = entry.getKey();
				Object val = entry.getValue();
				if(childrenId.contains(key) && val instanceof List)
					newMap.put(key, filterList((List)val, childrenId, args));
				else
					newMap.put(key, val);
			}
			return newMap;
		}
		return null;
	}
	
	private List filterList(List list, List<String> childrenId, FunctionArgumens args) {
		ArrayList newList = new ArrayList();
		for(Object c : list) {
			if(c instanceof Map) {
				Object rtn = filterItem((Map)c, childrenId, args);
				if(rtn != null)
					newList.add(rtn);
			} else
				newList.add(c);
		}
		return newList;
	}

}
