package tool;

import bogda.common.IOKit;
import bogda.common.JsonAdapter;
import bogda.common.model.Model;
import bogda.common.model.ModelTrans;
import bogda.common.model.Prop;

import java.io.BufferedReader;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.util.ArrayList;
import java.util.regex.Pattern;

public class Rel {

    public static void main(String[] args) throws Exception {
        new Rel().read();
    }

    ArrayList<Node> roots = new ArrayList<>();
    Node root;
    String type;
    Node ctg;
    void read() throws Exception{
        BufferedReader r = new BufferedReader(new FileReader("d:/work_area/rels.txt"));
        String tmp;
        while ((tmp = r.readLine()) != null){
            readLine(tmp);
        }

        String json = ModelTrans.get().notMarkType().toJson(roots);
        json = JsonAdapter.formatJson(json);
        IOKit.writeContent(json, new FileOutputStream("d:/work_area/rels.json"));
    }

    private void readLine(String line){
        int preS = preS(line);
        String[] arr = line.trim().split("\\s+");
        readLine(preS, arr);
    }

    private void readLine(int preS, String[] arr) {
        int offset = preS;
        if(preS == 0){
            root = new Node(arr[0], "");
            roots.add(root);
        }

        if(preS <= 1)
            type = arr[1 - offset];

        if(preS <= 2) {
            ctg = new Node(arr[3 - offset], arr[2 - offset]);
            ctg.type = type;
            root.addSub(ctg);
        }

        if(preS <= 4) {
            Node node = new Node(arr[4 - offset], arr[5 - offset]);
            node.type = type;
            node.direction = Integer.parseInt(arr[6 - offset]);
            ctg.addSub(node);
        }
    }

    private ArrayList<Node> readNodes(String[] arr){
        ArrayList<Node> list = new ArrayList<>();
        Node current = null;
        for(String s : arr){
            if(!isCode(s)){
                current = new Node();
                current.name = s;
                list.add(current);
            } else {
                current.code = s;
            }
        }
        return list;
    }

    private boolean isCode(String s){
        String pattern = "^[A-Za-z0-9]+$";
        return Pattern.matches(pattern, s);
    }

    private int preS(String line){
        int s = 0;
        while (s < line.length()){
            if(!Character.isWhitespace(line.charAt(s)))
                break;
            s++;
        }
        return s;
    }

    @Model(type="node", ns="test")
    class Node {

        @Prop
        String name;

        @Prop
        String code;

        @Prop
        String type;

        @Prop(defaultValue="-1")
        int direction = -1;

        @Prop(name="children")
        ArrayList<Node> subs;

        public Node() {

        }

        public Node(String name, String code) {
            this.name = name;
            this.code = code;
        }

        public Node addSub(Node sub){
            if(subs == null)
                subs = new ArrayList<Node>();
            subs.add(sub);
            return sub;
        }

        public void toJson(StringBuilder json){

        }

    }

}
