package tool;

import bogda.common.IOKit;
import bogda.common.JsonAdapter;
import bogda.common.model.Model;
import bogda.common.model.ModelTrans;
import bogda.common.model.Prop;

import java.io.BufferedReader;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.util.ArrayList;
import java.util.regex.Pattern;

public class Space {

    public static void main(String[] args) throws Exception {
        new Space().read();
    }

    ArrayList<Node> roots = new ArrayList<>();
    Node[] current = new Node[5];
    void read() throws Exception{
        BufferedReader r = new BufferedReader(new FileReader("d:/work_area/space.txt"));
        String tmp;
        while ((tmp = r.readLine()) != null){
            readLine(tmp);
        }

        String json = ModelTrans.get().notMarkType().toJson(roots);
        json = JsonAdapter.formatJson(json);
        IOKit.writeContent(json, new FileOutputStream("d:/work_area/space.json"));
    }

    private void readLine(String line){
        int preS = preS(line);
        String[] arr = line.trim().split("\\s+");
        readLine(preS, arr);
    }

    private void readLine(int preS, String[] arr) {
        ArrayList<Node> nodes = readNodes(arr);
        if(nodes.size() > 0){
            int pos = preS;
            if(pos > 1)
                pos = (pos - 1) / 2 + 1;
            for (int i = pos; i < current.length; i++) {
                if(i - pos >= nodes.size())
                    break;
                Node node = nodes.get(i - pos);;
                if(i == 0)
                    roots.add(node);
                else
                    current[i - 1].addSub(node);

                current[i] = node;
            }
        }
    }

    private ArrayList<Node> readNodes(String[] arr){
        ArrayList<Node> list = new ArrayList<>();
        Node current = null;
        for(String s : arr){
            if(!isCode(s)){
                current = new Node();
                current.name = s;
                list.add(current);
            } else {
                current.code = s;
            }
        }
        return list;
    }

    private boolean isCode(String s){
        String pattern = "^[A-Za-z0-9]+$";
        return Pattern.matches(pattern, s);
    }

    private int preS(String line){
        int s = 0;
        while (s < line.length()){
            if(!Character.isWhitespace(line.charAt(s)))
                break;
            s++;
        }
        return s;
    }

    @Model(type="node", ns="test")
    class Node {

        @Prop
        String name;

        @Prop
        String code;

        //@Prop
        int level;

        @Prop(name="children")
        ArrayList<Node> subs;

        public Node() {

        }

        public Node(String name, String code) {
            this.name = name;
            this.code = code;
        }

        public Node addSub(Node sub){
            if(subs == null)
                subs = new ArrayList<Node>();
            subs.add(sub);
            sub.level = level + 1;
            return sub;
        }

        public void toJson(StringBuilder json){

        }

    }

}
